// Times are UK London revised on 1 Sep 2013
// Based on mid month times plus 15 mins to the nearest quarter hour - make sure you leave enough time for the chickens to go to bed - I left an addition 30mins after sunset

int sun_set[24] ={
  //  Jan    Feb    Mar    Apr    May    Jun    Jul    Aug    Sep    Oct    Nov    Dec
  18,00,  18,30,  19,00,  20,30,  21,30, 22,00, 22,00, 21,30, 20,30,  19,00,  18,30,  18,00 };

int sun_rise[24]={
  7,30,   7,15,   7,00,   6,45,   6,30,  6,00,  6,00,  6,30,  6,45,   7,00,   7,15,   7,30 };


//----------------------------------------------
// Start of Main Control Loop
//---------------------------------------------


void coop_initialise()
{   

  // Set pin modes
  pinMode(pinEN, OUTPUT);
  digitalWrite(pinEN, LOW);
  pinMode(pinIP1, OUTPUT);
  digitalWrite(pinIP1,LOW );
  pinMode(pinIP2, OUTPUT);
  digitalWrite(pinIP2,LOW);
  pinMode(backLight, OUTPUT);
  pinMode(FLED, OUTPUT);

  //Set initial state of the motors
  stateMotor= STOP;
  GlobTime = 0;
  CheckTempChange();
  //RTC_initialise();
}



void run_controller()
{
  SetFlashOn==false;
  lcd.clear();
  int LCDLightTimer=backLightTime;

  while (wait_on_escape(750)==0)
  {
    if (SetFlashOn==true)
      FlashLED();

    lcd.setCursor(3,0);
    lcd.print("    Down   Up");
    lcd.setCursor(0,1);
    print_time();
    print_door_time();
    lcd.setCursor(0,2);
    lcd.print("Temp   Min    Max");
    print_max_min_temp();
    print_current_temp();

    if (WakeTime==GlobTime)
      door_change(DoorUp);

    if (BedTime==GlobTime)
      door_change(DoorDown);

    MotorOnTime = rtc[0];

    while (stateMotor != STOP)
    {
      RTC.get(rtc,true);

      if (rtc[0]>=(MotorOnTime+MotorFailSafe))
        door_change(Overide);

      else
        door_change(0);
    }

    if(LCDLightTimer==0)
      digitalWrite(backLight, LOW);
    LCDLightTimer--;
  }
}

//--------------------------------------------------
// End of Main Control Loop
//--------------------------------------------------


//--------------------------------------------------
// printing and setting the Sunrise and Sunset times
//--------------------------------------------------



void print_door_time()
{
  lcd.setCursor(7,1);
  RTC.get(rtc,true);

  if(sun_set[((rtc[5]-1)*2)] < 10)
    lcd.print('0');  
  lcd.print(sun_set[((rtc[5]-1)*2)]);
  lcd.print(":");
  if(sun_set[((rtc[5]-1)*2)+1] < 10)
    lcd.print('0');  
  lcd.print(sun_set[((rtc[5]-1)*2)+1]);

  lcd.setCursor(14,1);
  RTC.get(rtc,true);

  if(sun_rise[((rtc[5]-1)*2)] < 10)
    lcd.print('0');  
  lcd.print(sun_rise[((rtc[5]-1)*2)]);
  lcd.print(":");
  if(sun_rise[((rtc[5]-1)*2)+1] < 10)
    lcd.print('0');  
  lcd.print(sun_rise[((rtc[5]-1)*2)+1]);

}


void set_door_time()
{
  lcd.clear();
  lcd.print("Mth  Down   Up");

  int user_input=rtc[5];
  phi_prompt_struct myIntegerInput;
  myIntegerInput.ptr.i_buffer=&user_input;
  myIntegerInput.low.i=1;
  myIntegerInput.high.i=12;
  myIntegerInput.step.i=1;
  myIntegerInput.col=0;
  myIntegerInput.row=1;
  myIntegerInput.width=2;
  myIntegerInput.option=1;
  input_integer(&myIntegerInput);

  int month=user_input-1;
  lcd.setCursor(5,1);
  if(sun_set[(month*2)] < 10)
    lcd.print('0');  
  lcd.print(sun_set[(month*2)]);
  lcd.print(":");
  if(sun_set[(month*2)+1] < 10)
    lcd.print('0');  
  lcd.print(sun_set[(month*2)+1]);

  lcd.setCursor(12,1);
  if(sun_rise[(month*2)] < 10)
    lcd.print('0');  
  lcd.print(sun_rise[(month*2)]);
  lcd.print(":");
  if(sun_rise[(month*2)+1] < 10)
    lcd.print('0');  
  lcd.print(sun_rise[(month*2)+1]);

  user_input=sun_set[month*2];
  myIntegerInput.low.i=0;
  myIntegerInput.high.i=23;
  myIntegerInput.col=5;
  input_integer(&myIntegerInput);
  sun_set[month*2]=user_input;

  user_input=sun_set[(month*2)+1];
  myIntegerInput.low.i=0;
  myIntegerInput.high.i=59;
  myIntegerInput.col=8;
  input_integer(&myIntegerInput);
  sun_set[(month*2)+1]=user_input;

  user_input=sun_rise[month*2];
  myIntegerInput.low.i=0;
  myIntegerInput.high.i=23;
  myIntegerInput.col=12;
  input_integer(&myIntegerInput);
  sun_rise[month*2]=user_input;

  user_input=sun_rise[(month*2)+1];
  myIntegerInput.low.i=0;
  myIntegerInput.high.i=59;
  myIntegerInput.col=15;
  input_integer(&myIntegerInput);
  sun_rise[(month*2)+1]=user_input;
  wait_on_escape(2000);

}



//----------------------------------------------
// Door change and set 
// the State Motor variable to Stop
//---------------------------------------------

void door_change(int action){

  if (action == Overide ){                //  MD Motor Overide Command
    lcd.setCursor(0, 3);
    lcd.print(" Overide Controller ");     // Confirm to user limit switch had to be over writen
    digitalWrite(pinEN,LOW);
    digitalWrite(pinIP1,LOW);
    digitalWrite(pinIP2,LOW);
    stateMotor = STOP;
    SetFlashOn = true;
    delay(60000);
    return;
  }


  if (action == DoorDown ){                //  MD Motor Down Command
    if (button_check(pinLiB)==0){
      lcd.setCursor(0, 3);
      lcd.print("Door CLOSED");     // Confirm to user if manual button pressed that the door is CLOSED - shouty mode
      digitalWrite(pinEN,LOW);
      digitalWrite(pinIP1,LOW);
      digitalWrite(pinIP2,LOW);
      stateMotor = STOP;
      SetFlashOn=false;
      digitalWrite(FLED,HIGH);

    }
    else{
      lcd.setCursor(0, 3);
      lcd.print("Closing Door       ");            // Symbol to show door state going down
      digitalWrite(pinEN,HIGH);
      analogWrite(pinIP1,DownRate);         // Used analogue write to control the rate of the door closing - don't want to loose any heads!!
      digitalWrite(pinIP2,LOW);
      stateMotor = DOWN;
    }
    return;
  }
  if (action == DoorUp ){                   // MU Motor Up Command
    if (button_check(pinLiT)==0){
      lcd.setCursor(0, 3);
      lcd.print("Door OPEN");       // Confirm to user if manual button pressed that the door is OPEN - shouty mode
      digitalWrite(pinEN,LOW);
      digitalWrite(pinIP1,LOW);
      digitalWrite(pinIP2,LOW);
      stateMotor = STOP;
      SetFlashOn=false;
      digitalWrite(FLED,LOW);
    }
    else{
      lcd.setCursor(0, 3);
      lcd.print("Opening Door        ");            // Symbol to show door state going up
      digitalWrite(pinEN,HIGH);
      digitalWrite(pinIP1,LOW);
      digitalWrite(pinIP2,HIGH);            // analogWrite not used as you need as much power you can get to raise the door quickly
      stateMotor = UP;
    }
    return;
  }
  else {
    if (stateMotor== DOWN && button_check(pinLiB) == 0){
      lcd.setCursor(0, 3);
      lcd.print("Door Closed          ");
      digitalWrite(pinEN,LOW);
      digitalWrite(pinIP1,LOW);
      digitalWrite(pinIP2,LOW);
      stateMotor = STOP;
    }
    if (stateMotor== UP && button_check(pinLiT) == 0){
      lcd.setCursor(0, 3);
      lcd.print("Door Open             ");
      digitalWrite(pinEN,LOW);
      digitalWrite(pinIP1,LOW);
      digitalWrite(pinIP2,LOW);
      stateMotor = STOP;
    }
  }
}



//----------------------------------------------
// Keyboard and limiter switches detect rountine.  
// Analogue 1 - Limter switch Top
// Analogue 0 - Limter switch Bottom
//---------------------------------------------


int button_check(int LimiterSw) 
{
  adc_key_in = analogRead(LimiterSw);
  key = get_key(adc_key_in);		                  // convert into key press

  if (key!= oldkey)				          // if keypress is detected
  {
    delay(debounce_delay);		                  // wait for debounce time
    adc_key_in = analogRead(LimiterSw);                   // read the value from the sensor  
    key = get_key(adc_key_in);		                  // convert into key press
    if (key != oldkey)				
    {			
      oldkey = key;
    }
  }
  return (key);
}


int get_key(int input)
{
  int k;
  for (k = 0; k < NumKeys; k++)
  {
    if (input < adc_key_val[k])
    {         
      return k;
    }
  }  
  return -1;
}


void show_credit()
{
  // Display credits
  phi_prompt_struct myLongMsg;

  lcd.clear();
  lcd.noBlink();
  center_text("About"); // Prompt user for input. Use center_text to display center-aligned.
  myLongMsg.ptr.msg_P=msg_00; // Assign the address of the text string to the pointer.
  myLongMsg.low.i=0; // Default text starting position. 0 is highly recommended.
  myLongMsg.high.i=strlen_P(msg_00); // Position of the last character in the text string, which is size of the string - 1.
  myLongMsg.step.c_arr[0]=lcd_rows-1; // rows to auto fit entire screen
  myLongMsg.step.c_arr[1]=lcd_columns-1; // one col list
  myLongMsg.col=0; // Display the text area starting at column 0
  myLongMsg.row=1; // Display the text area starting at row 0
  myLongMsg.option=1; // Option 0, display classic message, option 1, display message with scroll bar on right.

  text_area_P(&myLongMsg);
}

void FlashLED()
{
  if (toggle==1)
  {  
    digitalWrite(FLED,LOW);
    toggle=0;
  }
  else
  {
    digitalWrite(FLED,HIGH);
    toggle=1;
  }

}























































